//
//  ViewController.m
//  CellDynamicHeight
//
//  Created by ZSMAC on 2018/4/18.
//  Copyright © 2018年 张帅. All rights reserved.
//

#import "ViewController.h"
#import "ZSTableViewCell.h"
#import "MyModel.h"
#define SCREEN  [UIScreen mainScreen].bounds.size

@interface ViewController ()<UITableViewDelegate,UITableViewDataSource>{
    UITableView * _tableView;
    NSMutableArray * _dataArray;
}

@end

@implementation ViewController
- (void)initData {
    _dataArray=[[NSMutableArray alloc] init];
    
    NSArray * contents = @[@"奥术大师萨法第三方公司东莞市地方广东省分公司东方故事电饭锅水电费公司的分公司东方故事电饭锅是否更换是大法官就能发货的爆发式办公沙发是东方故事电饭锅地方是东方故事电饭锅",@"申达股份是大法官是大法官个水电费公司的分公司东方故事电饭锅是东方故事电饭锅水电费违法地方官史蒂夫是东方故事电饭锅水电费公司分管帝国时代风格",@"是东方故事电饭锅是大法官的韩国发货对方更好地发挥地方规划",@"水电费华斯股份红烧豆腐行高度闪电发货闪电发货是否可国防科技是大法官好深刻理解的复合弓是否更换是；离开对方答复后开始是大法官水电费公司分管",@"啊首都发多少发到上俺的沙发水电费啊是大法师打发斯蒂芬安抚俺的沙发阿斯蒂芬阿斯蒂芬阿斯蒂芬SFASDFASDF ASDF ASDF 水电费给对方是大法官梵蒂冈是梵蒂冈是东方故事电饭锅 是梵蒂冈是大法官是大法官发的规划对方过后电饭锅是梵蒂冈是东方故事电饭锅",];
    
    for (int i=0; i<3; i++) {
        for (NSString *str in contents) {
            MyModel * model = [[MyModel alloc] init];
            model.content=str;
            [_dataArray addObject:model];
        }
    }
    [_tableView reloadData];
}
- (void)viewDidLoad {
    [super viewDidLoad];
    _tableView=[[UITableView alloc] initWithFrame:CGRectMake(0, 0, SCREEN.width, SCREEN.height) style:UITableViewStyleGrouped];
    _tableView.dataSource=self;
    _tableView.delegate=self;
    [self.view addSubview:_tableView];
    [self initData];
}

#pragma mark UITableViewDataSource
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    return _dataArray.count;
}
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    static NSString * identifer = @"cellIdentifier";
    ZSTableViewCell * cell = [tableView dequeueReusableCellWithIdentifier:identifer];
    if (!cell) {
        cell=[[ZSTableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:identifer];
    }
    /*
     思路： 基于UITableViewDataSource 数据源方法 和 UITableViewDelegate 代理方法执行的先后顺序
     1.cell 持有 model对象
     2.在cell 里根据内从计算所有UI控件
     3.最后计算拿到最底部控件的bottom值 就是cell的最终高度，再赋值 给model 用来存储高度
     4.cellForRowAtIndexPath 执行完后 会接着执行 UITableViewDelegate 代理方法，在拿到计算好的高度用来返回即可。
     */

    MyModel * model = _dataArray[indexPath.row];
    cell.model=model;
    return cell;
}

#pragma mark UITableViewDelegate
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    [_tableView deselectRowAtIndexPath:indexPath animated:YES];
}
- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
    MyModel * model = _dataArray[indexPath.row];
    return model.cellHeight;//返回cell的高度
}
- (CGFloat)tableView:(UITableView *)tableView heightForHeaderInSection:(NSInteger)section {
    return 0.01f;
}
- (CGFloat)tableView:(UITableView *)tableView heightForFooterInSection:(NSInteger)section {
    return 0.01f;
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


@end
