//
//  ZSTableViewCell.m
//  CellDynamicHeight
//
//  Created by ZSMAC on 2018/4/18.
//  Copyright © 2018年 张帅. All rights reserved.
//

#import "ZSTableViewCell.h"
#import "UIView+GoodView.h"
#define SCREEN  [UIScreen mainScreen].bounds.size

@implementation ZSTableViewCell
- (id)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier {
    self=[super initWithStyle:style reuseIdentifier:reuseIdentifier];
    if (self) {
        [self uiConfigure];
    }
    return self;
}
- (void)setModel:(MyModel *)model {
    _model=model;
    self.content=_model.content;
}
- (void)uiConfigure {
    _showLabel = [[UILabel alloc] initWithFrame:CGRectMake(15, 10, SCREEN.width-30, 44)];
    _showLabel.font=[UIFont systemFontOfSize:15];
    _showLabel.numberOfLines=0;
    [self.contentView addSubview:_showLabel];

}

-(void)setContent:(NSString *)content {
    _content=content;
    _showLabel.text=_content;
    _showLabel.textColor= [UIColor colorWithRed: arc4random_uniform(256)/255.0f green: arc4random_uniform(256)/255.0f blue: arc4random_uniform(256)/255.0f alpha:1];
    CGSize size = [self workOutSizeWithStr:_content andFont:[UIFont systemFontOfSize:15] value:[NSValue valueWithCGSize:CGSizeMake(_showLabel.frame.size.width, MAXFLOAT)]];
    if (size.height>44) {
        _showLabel.height=size.height;
    } else {
        _showLabel.height=44;
    }
    //cell高度赋值
    _model.cellHeight= [UIView getBottomViewBottomFrom:self.contentView] +10;
}

//动态计算高度
- (CGSize)workOutSizeWithStr:(NSString *)str andFont:(UIFont*)font value:(NSValue *)value{
    CGSize size;
    if (str==nil) {
        str = @"";
    } else {
        NSDictionary *attribute = [NSDictionary dictionaryWithObjectsAndKeys:font,NSFontAttributeName, nil];
        size=[str boundingRectWithSize:[value CGSizeValue] options:NSStringDrawingUsesFontLeading |NSStringDrawingUsesLineFragmentOrigin |NSStringDrawingTruncatesLastVisibleLine attributes:attribute context:nil].size;
    }
    return size;
}
- (void)awakeFromNib {
    [super awakeFromNib];
    // Initialization code
}

- (void)setSelected:(BOOL)selected animated:(BOOL)animated {
    [super setSelected:selected animated:animated];

    // Configure the view for the selected state
}

@end
